/****************************************************************************
 *  This file is part of PPMVC project                                      *
 *  Written and distributed to public domain by Przemyslaw Skibinski, 2003  *
 *  Contents: Global order-0 model for encoding/decoding lenghts of matches *
 *            for variable-length contexts                                  *
 ****************************************************************************/

int* matchInLen;
int i,j,groups,maxGroups,commonAfter,totalMatchInLen;
int gmg;

inline void InitOrder0Match()
{
	maxGroups=maxRightMatchLen/groupMatches+1;
	matchInLen=new int[maxGroups+1];
	totalMatchInLen=0;
	groups=128/groupMatches;
	gmg=groupMatches*groups;

	for (i=0; i<=groups; i++)
	{
		matchInLen[i]=1;
		totalMatchInLen+=1;
	}
}

inline void UpdateOrder0Match()
{
	matchInLen[commonAfter]+=MATCH_STEP;
	totalMatchInLen+=MATCH_STEP;

	if (commonAfter==groups && groups<maxGroups)
	{
		matchInLen[++groups]=1;
		totalMatchInLen++;
		if (groups<maxGroups) 
		{
			matchInLen[++groups]=1;
			totalMatchInLen++;
		}
		gmg=groups*groupMatches;
	}

	if (totalMatchInLen >= 1<<15)  // rescale
	{
		totalMatchInLen=0;
		for (i=0; i<=groups; i++)
		{
			matchInLen[i]=(1+matchInLen[i])>>1;
			totalMatchInLen+=matchInLen[i];
		}
	}
}

inline void EncodeOrder0Match()
{
	SubRange.LowCount=0;
	for (i=0; i<commonAfter; i++)
		SubRange.LowCount+=matchInLen[i];
	SubRange.HighCount=SubRange.LowCount+matchInLen[commonAfter];
	SubRange.scale=totalMatchInLen;
	ariEncodeSymbol();

}

inline void DecodeOrder0Match()
{
	SubRange.scale=totalMatchInLen;
	commonAfter=ariGetCurrentCount();

	SubRange.LowCount=0;
	for (i=0; SubRange.LowCount+matchInLen[i]<=(unsigned int)commonAfter; i++)
		SubRange.LowCount+=matchInLen[i];

	commonAfter=i;
	SubRange.HighCount=SubRange.LowCount+matchInLen[commonAfter];
	ariRemoveSubrange();
}


